

addSpecialization = {};
addSpecialization.isLoaded = true;
addSpecialization.g_currentModDirectory = g_currentModDirectory;

if SpecializationUtil.specializations["autosteer"] == nil then
	SpecializationUtil.registerSpecialization("autosteer", "autosteer", g_currentModDirectory .. "autosteer.lua")
	addSpecialization.isLoaded = false;
else
	-- print("  autosteer have been loaded already!");
end;

addModEventListener(addSpecialization);

function addSpecialization:loadMap(name)
    if not addSpecialization.isLoaded then
	
		addSpecialization:add();
		
		g_currentMission.autoSteerHud = Overlay:new("autoSteerHud", Utils.getFilename("autoSteerHud.dds", addSpecialization.g_currentModDirectory.."Hud/"), 0.79, 0.85, 0.2044444, 0.039525);
		
        addSpecialization.isLoaded = true;
    end;
end;

function addSpecialization:deleteMap()
    addSpecialization.isLoaded = false;
	if g_currentMission.autoSteerHud ~= nil then
		g_currentMission.autoSteerHud:delete();
	end;
end;

function addSpecialization:mouseEvent(posX, posY, isDown, isUp, button)
end;

function addSpecialization:keyEvent(unicode, sym, modifier, isDown)
end;

function addSpecialization:update(dt)
end;

function addSpecialization:draw()
end;

function addSpecialization:add()
	local searchTable = {
		"autosteer",
		"autoSteer",
		"AutoSteer"
		};
	
	for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
		local modName = string.match(k, "([^.]+)");
		
		local addSpecialization = true;
		for _, search in pairs(searchTable) do			
			if SpecializationUtil.specializations[modName .. "." .. search] ~= nil then
				addSpecialization = false;
				break;
			end;
		end;
		
		if SpecializationUtil.hasSpecialization(autosteer, v.specializations) then
			addSpecialization = false;
			break;
		end;
		
		local correctLocation = false;
		for i = 1, table.maxn(v.specializations) do
			local vs = v.specializations[i];
			if vs ~= nil and vs == SpecializationUtil.getSpecialization("steerable") then
				correctLocation = true;
				break;
			end;
		end;
		
		if addSpecialization and correctLocation then
			table.insert(v.specializations, SpecializationUtil.getSpecialization("autosteer"));
		elseif correctLocation and not addSpecialization then
			-- print("  Failed to inserting autosteer on " .. k);
		end;
	end;
	
	-- make l10n global 
	local i = 1;
	while true do
		local txt = string.format("AUTOSTEER_%d", i);
		if not g_i18n:hasText(txt) then break; end;
		
		g_i18n.globalI18N.texts[txt] = g_i18n:getText(txt);
		
		i = i + 1;
	end;
end;